indexing
   description: "Sets up the main window."
   status: "Free according to the GPL license (see COPYING)"
   date: "$Date$"
   revision: "$Revision$"
   author: "Mark Arrasmith <arrasmith@math.twsu.edu> and Miron Brezuleanu"
   

class EFRACTAL_WINDOW
   
inherit
   EXG_MAIN_WINDOW
      redefine
	 make
      end
   GTK_COMMAND  
   STARTUP
   GTK_CONSTANTS
   
creation
   make
   
feature
   
   file_menu: GTK_MENU_ITEM is
	 -- will return a `GTK_MENU_ITEM' linked to the file menu
      local
	 m: GTK_MENU
	 mi: GTK_MENU_ITEM
      once
	 !!m.make
	 
	 !!mi.make_with_label("Open Parameter File")
	 mi.signal_connect("activate", Current, "open_param")
	 mi.show
	 m.append(mi)

	 !!mi.make_with_label("Save Parameter File")
	 mi.signal_connect("activate", Current, "save_param")
	 mi.show
	 m.append(mi)
	 
	 !!mi.make_with_label("Save Image")
	 mi.signal_connect("activate", Current, "save_image")
	 mi.show
	 m.append(mi)	 	 
	 	 
	 !!mi.make_with_label("Quit")
	 mi.signal_connect("activate", Current, "quit")
	 mi.show
	 m.append(mi)	 	 
	 
	 !!mi.make_with_label("File")
	 mi.set_submenu(m)
	 mi.show	 
	 
	 Result := mi
      end
   
   types_menu: GTK_MENU_ITEM is
     -- will return 'GTK_MENU_ITEM' linked to the types menu
	 local
	 m: GTK_MENU
	 mi: GTK_MENU_ITEM
	 once
	 !!m.make
	 
	 !!mi.make_with_label("Fractal Types")
	 mi.signal_connect("activate", Current, "types")
	 mi.show
	 m.append(mi)
	 
	 !!mi.make_with_label("Parameters")
	 mi.signal_connect("activate", Current, "params")
	 mi.show
	 m.append(mi) 
	 
	 !!mi.make_with_label("Image Size")
	 mi.signal_connect("activate", Current, "size")
	 mi.show
	 m.append(mi)	 	 
	 
	 !!mi.make_with_label("Edit Zoombox")
	 mi.signal_connect("activate", Current, "zoom")
	 mi.show
	 m.append(mi) 
	 
	 !!mi.make_with_label("Clear Zoombox")
	 mi.signal_connect("activate", Current, "clear")
	 mi.show
	 m.append(mi)
	 
	 !!mi.make_with_label("Undo Zoom")
	 mi.signal_connect("activate", Current, "unzoom")
	 mi.show
	 m.append(mi)
	 
	 !!mi.make_with_label("Fractals")
	 mi.set_submenu(m)
	 mi.show	 
	 
	 Result := mi
	 end

   
   color_menu: GTK_MENU_ITEM is
	 -- will return `GTK_MENU_ITEM' linked to the color menu
      local
	 m: GTK_MENU
	 mi: GTK_MENU_ITEM
      once
	 !!m.make
	 
	 !!mi.make_with_label("Choose Color Functions")
	 mi.signal_connect("activate", Current, "color")
	 mi.show
	 m.append(mi)
	 
	 !!mi.make_with_label("Edit Gradient Map")
	 mi.signal_connect("activate", Current, "edit gradient")
	 mi.show
	 m.append(mi) 
	 
	 !!mi.make_with_label("Colors")
	 mi.set_submenu(m)
	 mi.show	 
	 
	 Result := mi
      end
	  
   help_menu: GTK_MENU_ITEM is
	 -- will return `GTK_MENU_ITEM' linked to the help menu
      local
	 m: GTK_MENU
	 mi: GTK_MENU_ITEM
      once
	 !!m.make
	 
	 --!!mi.make_with_label("Overview")
	 --mi.signal_connect("activate", Current, "overview")
	 --mi.show
	 --m.append(mi)
	 
	 !!mi.make_with_label("About")
	 mi.signal_connect("activate", Current, "about")
	 mi.show
	 m.append(mi) 
	 
	 !!mi.make_with_label("Help")
	 mi.set_submenu(m)
	 mi.show	 
	 
	 Result := mi
      end
   
   make is   
      local
	 mb: GTK_MENU_BAR
	 vbox: GTK_VBOX
      do
	 Precursor
	 set_usize(420, 340)
	 
	 !!mb.make
	 mb.append(file_menu)	 
	 mb.append(types_menu)
	 mb.append(color_menu)
	 mb.append(help_menu)
	 help_menu.right_justify
	 
	 !!vbox.make(False, 0)
	 vbox.pack_start(mb, False, False, 0)
	 mb.show

	 !! esac.make(efractal_canvas)
	 vbox.pack_start(esac, True, True, 0)
	 esac.show

	 add(vbox)
	 vbox.show
      end
   
   execute(d: ANY) is
      local
	 s: STRING
	 emb: EXG_MESSAGE_BOX
      do
	 s ?= d
	 check
	    s /= Void
	 end
	 if equal(s, "size") then
	    efractal_canvas.new_size
		esac.alignment.set_usize(config.width, config.height)
	 elseif equal(s, "unzoom") then
	    efractal_canvas.undo_zoom
	 elseif equal(s, "clear") then
	    efractal_canvas.clear_zoombox
	 elseif equal(s, "save_image") then
	    efractal_canvas.save_image
	 elseif equal(s, "open_param") then
	    efractal_canvas.load
		if efractal_canvas.filename /= Void then
		  config.set_file_name(efractal_canvas.filename)
		  esac.alignment.set_usize(config.width, config.height)
		end
	 elseif equal(s, "save_param") then
	    efractal_canvas.save
		if efractal_canvas.filename /= Void then
		  config.set_file_name(efractal_canvas.filename)
		end
	 elseif equal(s, "quit") then
	    quit
	 elseif equal(s, "edit gradient") then
	    gradient_editor.show
	    gradient_editor.raise
	 elseif equal(s, "color") then
		efractal_canvas.new_colors
	 elseif equal(s, "types") then
		efractal_canvas.new_type
		config.set_file_name("(untitled)")
	 elseif equal(s, "params") then
		efractal_canvas.new_params
	 elseif equal(s, "zoom") then
		efractal_canvas.new_zoombox
	 elseif equal(s, "about") then
		!!emb.make
		emb.set_title("About eFractal - 0.3.5")
		emb.set_pixmap(exg_default_pixmaps.at("question"))
		emb.set_message("%N"
		     + " eFractal: a fractal program written in Eiffel  "
			 + "%N%N"
			 + " (c) 1999-2000 Mark Arrasmith <arrasmith@math.twsu.edu>  "
			 + "%N%N"
			 + " This program is free software under the terms of the%N"
			 + " GPL and comes WITHOUT ANY WARRANTY.%N"
			 + " See 'COPYING' for details.%N")
		emb.run
	 end
	 set_title("eFractal - " + config.file_name)
      end

	
	 esac: EXG_SCROLLED_ALIGNED_CANVAS
   
end --EFRACTAL_WINDOW
